var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import ColorPicker from './ColorPicker';
import { createComponent } from 'cf-style-container';
import { InputTheme } from 'cf-component-input';

var CoverDiv = createComponent(function () {
  return {
    position: 'fixed',
    top: '0px',
    right: '0px',
    bottom: '0px',
    left: '0px'
  };
}, 'div', ['onClick']);
CoverDiv.setDisplayName('CoverDiv');

var PopoverDiv = createComponent(function () {
  return {
    position: 'absolute',
    zIndex: '2'
  };
}, 'div');
PopoverDiv.setDisplayName('PopoverDiv');

var FakeInputDiv = createComponent(function (_ref) {
  var theme = _ref.theme;

  return Object.assign({}, InputTheme(theme), {
    padding: '.6em .9em'
  });
}, 'div', ['onClick']);
FakeInputDiv.setDisplayName('FakeInputDiv');

var ColorDisplayDiv = createComponent(function (_ref2) {
  var theme = _ref2.theme,
      color = _ref2.color,
      defaultColor = _ref2.defaultColor;

  return {
    background: color || defaultColor,
    height: '100%',
    width: '100%',
    borderWidth: '1px',
    borderStyle: 'solid',
    borderColor: theme.color.hail
  };
}, 'div');
ColorDisplayDiv.setDisplayName('ColorDisplayDiv');

var ColorPickerInput = function (_React$Component) {
  _inherits(ColorPickerInput, _React$Component);

  function ColorPickerInput(props) {
    _classCallCheck(this, ColorPickerInput);

    var _this = _possibleConstructorReturn(this, (ColorPickerInput.__proto__ || Object.getPrototypeOf(ColorPickerInput)).call(this, props));

    _this.state = {
      displayColorPicker: false
    };

    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleClose = _this.handleClose.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(ColorPickerInput, [{
    key: 'handleClick',
    value: function handleClick(e) {
      e.preventDefault();
      this.setState({ displayColorPicker: !this.state.displayColorPicker });
    }
  }, {
    key: 'handleClose',
    value: function handleClose() {
      this.setState({ displayColorPicker: false });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(color) {
      this.props.onChange({ value: color.hex });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          defaultEmptyValue = _props.defaultEmptyValue,
          value = _props.value;

      return React.createElement(
        'div',
        null,
        React.createElement(
          FakeInputDiv,
          { onClick: this.handleClick },
          React.createElement(ColorDisplayDiv, { color: value, defaultColor: defaultEmptyValue })
        ),
        this.state.displayColorPicker ? React.createElement(
          PopoverDiv,
          null,
          React.createElement(CoverDiv, { onClick: this.handleClose }),
          React.createElement(ColorPicker, { color: value, onChange: this.handleChange })
        ) : null
      );
    }
  }]);

  return ColorPickerInput;
}(React.Component);

ColorPickerInput.propTypes = {
  defaultEmptyValue: PropTypes.string,
  onChange: PropTypes.func,
  value: PropTypes.string
};

export default ColorPickerInput;